// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package alarm

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
)

func AlarmIncreaseStatistic(ctx context.Context, req *v1.AlarmIncreaseStatisticRequest) (reply *v1.AlarmIncreaseStatisticReply, err error) {

	dayIncrease, monthIncrease, total, err := model.AlarmIncreaseStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}

	reply = &v1.AlarmIncreaseStatisticReply{}
	reply.DayIncrease = dayIncrease
	reply.Total = total
	reply.MonthIncrease = monthIncrease
	return reply, nil
}
