// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package alarm

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
)

func AlarmDeviceStatistic(ctx context.Context, req *v1.AlarmDeviceStatisticRequest) (reply *v1.AlarmDeviceStatisticReply, err error) {

	list, err := model.AlarmDeviceStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}

	reply = &v1.AlarmDeviceStatisticReply{}
	for _, v := range list {
		switch v.DeviceCode {
		case model.DeviceTypeTower:
			reply.TowerAlarmCount = v.Count
		case model.DeviceTypeDust:
			reply.DustAlarmCount = v.Count
		case model.DeviceTypeStaff:
			reply.StaffAlarmCount = v.Count
		case model.DeviceTypeVehicle:
			reply.VehicleAlarmCount = v.Count
		}
	}
	reply.TotalAlarmCount = reply.TowerAlarmCount+reply.DustAlarmCount+reply.VehicleAlarmCount+reply.StaffAlarmCount

	return reply, nil
}
