// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package company

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
)


func ProjectStatistic(ctx context.Context, req *v1.ProjectStatisticRequest) (reply *v1.ProjectStatisticReply, err error) {

	reply = &v1.ProjectStatisticReply{}
	ret, err := model.ProjectStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}
	reply.Total = ret.Total
	reply.Increase = ret.Increase

	mreply, err := ProjectTypeStatistic(ctx, &v1.ProjectTypeStatisticRequest{})
	if err != nil {
		return nil, err
	}
	reply.List = mreply.List

	return reply, nil
}
