// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package company

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
	"strconv"
)

func ProjectTypeStatistic(ctx context.Context, req *v1.ProjectTypeStatisticRequest) (reply *v1.ProjectTypeStatisticReply, err error) {

	reply = &v1.ProjectTypeStatisticReply{}
	list, err := model.ProjectTypeStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}
	reply.List = make([]*v1.ProjectTypeStatisticItem, len(list))
	total := int64(0)
	for i, v := range list {
		item := &v1.ProjectTypeStatisticItem{
			ProjectType: v.ProjectType,
			Count:v.Count,
		}
		reply.List[i] = item
		total += v.Count
	}
	for i, v := range reply.List {
		reply.List[i].Percent = strconv.FormatFloat(float64(v.Count * 100)/float64(total), 'f', 2, 64) + "%"
	}


	return reply, nil
}
