// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package company

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
	"time"
)


func StaffStatistic(ctx context.Context, req *v1.StaffStatisticRequest) (reply *v1.StaffStatisticReply, err error) {

	reply = &v1.StaffStatisticReply{}
	p := model.TStaff{}
	reply.Total, err = p.Count(database.DB(), nil)
	if err != nil {
		return nil, errors.DataBaseError
	}

	now := time.Now()
	nowStart := time.Date(now.Year(), now.Month(), 1, 0, 0, 0, 0, now.Location())
	where := map[string]interface{}{
		"created_at >=": nowStart.Format("2006-01-02 15:04:05"),
	}
	reply.Increase, err = p.Count(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}

	pa := model.TStaffAttendance{}
	date := time.Date(now.Year(), now.Month(), now.Day(), 0, 0, 0, 0, now.Location())
	where = map[string]interface{}{
		"day_time": date,
		"in_out":model.StaffAttendanceIn,
	}
	reply.Attendance, err = pa.Count(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}
	return reply, nil
}
