// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
)

func DeviceStatistic(ctx context.Context, req *v1.DeviceStatisticRequest) (reply *v1.DeviceStatisticReply, err error) {
	reply = &v1.DeviceStatisticReply{}
	ret, err := model.DeviceStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}
	reply.Online = ret.Online
	reply.Total = ret.Total
	reply.Offline = ret.Offline
	reply.Increase = ret.Increase
	return reply, nil
}
