// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"smart-government-management/errors"
	"smart-government-management/model"
	"smart-government-management/pb/v1"
)

func DeviceTypeStatistic(ctx context.Context, req *v1.DeviceTypeStatisticRequest) (reply *v1.DeviceTypeStatisticReply, err error) {
	reply = &v1.DeviceTypeStatisticReply{}

	pt := &model.TDeviceTypeItem{}
	m, _, err := pt.AllMap(database.DB())
	if err != nil {
		logger.Error("DeviceList",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}


	p := &model.TDevice{}

	list, err := p.DeviceTypeStatistic(database.DB())
	if err != nil {
		return nil, errors.DataBaseError
	}
	reply.List = make([]*v1.DeviceTypeStatisticItem, len(list))
	for i, v := range list {
		item := &v1.DeviceTypeStatisticItem{
			DeviceType:m[v.TypeCode],
			Total:v.Total,
			Online:v.Online,
			DeviceCode:v.TypeCode,
		}
		reply.List[i] = item
	}

	return reply, nil
}
