// Copyright 2019  githup.com. All rights reserved.
// Use of this source code is governed by  githup.com.
package user

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"github.com/jinzhu/gorm"
	"go.uber.org/zap"
	"smart-government-management/errors"
	dbmodel "smart-government-management/model"
	pb_v1 "smart-government-management/pb/v1"
)

func EmailPrepare(ctx context.Context, req *pb_v1.EmailPrepareRequest)(reply *pb_v1.EmailPrepareReply, err error) {
	p := &dbmodel.TSystemAdmin{}
	if req.Password == "" || req.Email == "" {
		return nil, errors.ParamsError
	}
	where := map[string]interface{}{
		"id":req.Id,
	}
	// 状态判断
	err = p.Find(database.DB(), where)
	if err != nil && err != gorm.ErrRecordNotFound{
		logger.Error("EmailPrepare",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.NoRecordError
	}



	pass, _ := getMd5Pass(req.Password)
	if p.Passwd != pass {
		return nil, errors.UserPassError
	}

	p = &dbmodel.TSystemAdmin{}
	where = map[string]interface{}{
		"email":req.Email,
	}
	// 状态判断
	err = p.Find(database.DB(), where)
	if err != nil && err != gorm.ErrRecordNotFound{
		logger.Error("EmailPrepare",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id > 0 {
		return nil, errors.EmailExist
	}

	reply = &pb_v1.EmailPrepareReply{}
	return reply, nil
}
