// Copyright 2019  githup.com. All rights reserved.
// Use of this source code is governed by  githup.com.
package user

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"github.com/jinzhu/gorm"
	"go.uber.org/zap"
	"smart-government-management/errors"
	dbmodel "smart-government-management/model"
	pb_v1 "smart-government-management/pb/v1"
)

func GetPhone(ctx context.Context, req *pb_v1.GetPhoneRequest)(reply *pb_v1.GetPhoneReply, err error) {
	if req.Uid == 0 {
		return nil, errors.ParamsError
	}
	p := &dbmodel.TSystemAdmin{}
	where := map[string]interface{}{"id":req.Uid}
	err = p.Find(database.DB(), where)
	if err != nil && err != gorm.ErrRecordNotFound {
		logger.Error("GetPhone",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.UserNotExistError
	}

	reply = &pb_v1.GetPhoneReply{
		Phone:p.Phone,
		Email:p.Email,
	}
	return reply, nil
}
