// Copyright 2019 github.com. All rights reserved.
// Use of this source code is governed by github.com.

package model

import (
	"github.com/jinzhu/gorm"
	"time"
)

type TSystemAdmin struct {
	Id int64 `gorm:"column:id" json:"id" form:"id"`
	Name string `gorm:"column:name" json:"name" form:"name"`
	Passwd string `gorm:"column:passwd" json:"passwd" form:"passwd"`
	CreatedAt time.Time `gorm:"column:created_at" json:"created_at" form:"created_at"`
	UpdatedAt time.Time `gorm:"column:updated_at" json:"updated_at" form:"updated_at"`
	Develop int32 `json:"develop"`
	Phone string
	Email string
}


func (TSystemAdmin) TableName() string {
	return "t_system_admin"
}

func (p *TSystemAdmin) Insert(db *gorm.DB) error {
	return db.Create(p).Error
}

func (p *TSystemAdmin) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *TSystemAdmin) Update(db *gorm.DB, where map[string]interface{}, values map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}

	return db.Table(p.TableName()).Table(p.TableName()).Where(cond, val...).Updates(values).Error
}

func (p *TSystemAdmin) UpdatePhoneNull(db *gorm.DB, id int64) error {
	sql := "update t_system_admin set phone=null where id=?"
	return db.Exec(sql, id).Error
}

func (p *TSystemAdmin) FindSort(db *gorm.DB, where map[string]interface{}, sort string) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	ps := []TSystemAdmin{}
	err = db.Table(p.TableName()).Where(cond, val...).Order(sort).Limit(1).Find(&ps).Error
	if err != nil {
		return err
	}
	if len(ps) > 0 {
		*p = ps[0]
	}
	return nil
}


func (p *TSystemAdmin) Save(db *gorm.DB) error {
	return db.Save(p).Error
}


func (p *TSystemAdmin) List(db *gorm.DB, where map[string]interface{}, or map[string]interface{}, page int) (list []TSystemAdmin, err error) {
	if len(where) > 0 {
		cond, val, err := whereBuildAndOr(where, or)
		if err != nil {
			return list, err
		}

		result := db.Table(p.TableName()).Where(cond, val...).Limit(PageSize).Offset(page).Find(&list)

		return list, result.Error
	}
	result := db.Table(p.TableName()).Limit(10).Offset(page).Find(&list)

	return list, result.Error
}

func (p *TSystemAdmin) All(db *gorm.DB) (list []TProvider, err error) {

	result := db.Table(p.TableName()).Find(&list)

	return list, result.Error
}

func (p *TSystemAdmin) Count(db *gorm.DB, where map[string]interface{}, or map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuildAndOr(where, or)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *TSystemAdmin) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}
