// Copyright 2019  githup.com. All rights reserved.
// Use of this source code is governed by  githup.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jinzhu/gorm"
	"smart-government-management/consts"
	"smart-government-management/errors"
	dbmodel "smart-government-management/model"
	pb_v1 "smart-government-management/pb/v1"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"time"
)

const (
	// 0 供应商入驻审批 1 设备对接审批 2 设备入库审批 3 拆机审批
	ApproveTypeProvider = iota
	ApproveTypeDeviceDocking
	ApproveTypeDeviceAdd
	ApproveTypeDeviceDel
)

// 已废弃
func DockingApprove(ctx context.Context, req *pb_v1.DockingApproveRequest)(reply *pb_v1.DockingApproveReply, err error) {
	return nil, errors.SystemError
	p := &dbmodel.TProviderDevice{}
	where := map[string]interface{}{
		"id":req.Id,
	}
	// 状态判断
	err = p.Find(database.DB(), where)
	if err != nil && err != gorm.ErrRecordNotFound {
		logger.Error("DockingApprove",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.NoRecordError
	}
	if p.Status != consts.DeviceTypeStatusAddTesting {
		return nil, errors.CanNotApproveWithStatus
	}

	// 更新
	where = map[string]interface{}{
		"id":req.Id,
		"status":consts.DeviceTypeStatusAddTesting,
	}
	value := map[string]interface{}{
		"status":consts.DeviceTypeStatusAddTestted,
		"comment":req.Comment,
		"develop_approve_time":time.Now(),
	}
	if !req.Status {
		value["status"] = consts.DeviceTypeStatusAddTesttedFail
	}
	err = p.Update(database.DB(), where, value)
	if err != nil {
		logger.Error("DockingApprove",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	return &pb_v1.DockingApproveReply{}, nil
}
